diff --git a/sys/contrib/dev/acpica/source/include/actbl2.h b/sys/contrib/dev/acpica/source/include/actbl2.h
index eaa2e243e8..a74b6d555a 100644
--- a/sys/contrib/dev/acpica/source/include/actbl2.h
+++ b/sys/contrib/dev/acpica/source/include/actbl2.h
@@ -1804,332 +2649,211 @@ typedef struct nfit_device_handle
 
 /*******************************************************************************
  *
- * NHLT - Non HD Audio Link Table
- *
- * Conforms to: Intel Smart Sound Technology NHLT Specification
- * Version 0.8.1, January 2020.
+ * NHLT - Non HDAudio Link Table
+ *        Version 1
  *
  ******************************************************************************/
 
-/* Main table */
-
 typedef struct acpi_table_nhlt
 {
-    ACPI_TABLE_HEADER       Header;             /* Common ACPI table header */
-    UINT8                   EndpointCount;
+    ACPI_TABLE_HEADER              Header;          /* Common ACPI table header */
+    UINT8                          EndpointsCount;
+    /*
+     * ACPI_NHLT_ENDPOINT          Endpoints[];
+     * ACPI_NHLT_CONFIG            OEDConfig;
+     */
 
 } ACPI_TABLE_NHLT;
 
-typedef struct acpi_table_nhlt_endpoint_count
-{
-    UINT8                   EndpointCount;
-
-} ACPI_TABLE_NHLT_ENDPOINT_COUNT;
-
 typedef struct acpi_nhlt_endpoint
 {
-    UINT32                  DescriptorLength;
-    UINT8                   LinkType;
-    UINT8                   InstanceId;
-    UINT16                  VendorId;
-    UINT16                  DeviceId;
-    UINT16                  RevisionId;
-    UINT32                  SubsystemId;
-    UINT8                   DeviceType;
-    UINT8                   Direction;
-    UINT8                   VirtualBusId;
+    UINT32                         Length;
+    UINT8                          LinkType;
+    UINT8                          InstanceId;
+    UINT16                         VendorId;
+    UINT16                         DeviceId;
+    UINT16                         RevisionId;
+    UINT32                         SubsystemId;
+    UINT8                          DeviceType;
+    UINT8                          Direction;
+    UINT8                          VirtualBusId;
+    /*
+     * ACPI_NHLT_CONFIG            DeviceConfig;
+     * ACPI_NHLT_FORMATS_CONFIG    FormatsConfig;
+     * ACPI_NHLT_DEVICES_INFO      DevicesInfo;
+     */
 
 } ACPI_NHLT_ENDPOINT;
 
-/* Types for LinkType field above */
-
-#define ACPI_NHLT_RESERVED_HD_AUDIO         0
-#define ACPI_NHLT_RESERVED_DSP              1
-#define ACPI_NHLT_PDM                       2
-#define ACPI_NHLT_SSP                       3
-#define ACPI_NHLT_RESERVED_SLIMBUS          4
-#define ACPI_NHLT_RESERVED_SOUNDWIRE        5
-#define ACPI_NHLT_TYPE_RESERVED             6 /* 6 and above are reserved */
+/* Values for LinkType field above */
 
-/* All other values above are reserved */
+#define ACPI_NHLT_LINKTYPE_HDA               0
+#define ACPI_NHLT_LINKTYPE_DSP               1
+#define ACPI_NHLT_LINKTYPE_PDM               2
+#define ACPI_NHLT_LINKTYPE_SSP               3
+#define ACPI_NHLT_LINKTYPE_SLIMBUS           4
+#define ACPI_NHLT_LINKTYPE_SDW               5
+#define ACPI_NHLT_LINKTYPE_UAOL              6
 
 /* Values for DeviceId field above */
 
-#define ACPI_NHLT_PDM_DMIC                  0xAE20
-#define ACPI_NHLT_BT_SIDEBAND               0xAE30
-#define ACPI_NHLT_I2S_TDM_CODECS            0xAE23
+#define ACPI_NHLT_DEVICEID_DMIC              0xAE20
+#define ACPI_NHLT_DEVICEID_BT                0xAE30
+#define ACPI_NHLT_DEVICEID_I2S               0xAE34
 
 /* Values for DeviceType field above */
 
-/* SSP Link */
-
-#define ACPI_NHLT_LINK_BT_SIDEBAND          0
-#define ACPI_NHLT_LINK_FM                   1
-#define ACPI_NHLT_LINK_MODEM                2
-/* 3 is reserved */
-#define ACPI_NHLT_LINK_SSP_ANALOG_CODEC     4
-
-/* PDM Link */
-
-#define ACPI_NHLT_PDM_ON_CAVS_1P8           0
-#define ACPI_NHLT_PDM_ON_CAVS_1P5           1
+/* Device types unique to endpoint of LinkType=PDM */
+#define ACPI_NHLT_DEVICETYPE_PDM             0
+#define ACPI_NHLT_DEVICETYPE_PDM_SKL         1
+/* Device types unique to endpoint of LinkType=SSP */
+#define ACPI_NHLT_DEVICETYPE_BT              0
+#define ACPI_NHLT_DEVICETYPE_FM              1
+#define ACPI_NHLT_DEVICETYPE_MODEM           2
+#define ACPI_NHLT_DEVICETYPE_CODEC           4
 
 /* Values for Direction field above */
 
-#define ACPI_NHLT_DIR_RENDER                0
-#define ACPI_NHLT_DIR_CAPTURE               1
-#define ACPI_NHLT_DIR_RENDER_LOOPBACK       2
-#define ACPI_NHLT_DIR_RENDER_FEEDBACK       3
-#define ACPI_NHLT_DIR_RESERVED              4   /* 4 and above are reserved */
-
-/* Capabilities = 2 */
-
-typedef struct acpi_nhlt_device_specific_config
-{
-    UINT32                  CapabilitiesSize;
-    UINT8                   VirtualSlot;
-    UINT8                   ConfigType;
-
-} ACPI_NHLT_DEVICE_SPECIFIC_CONFIG;
-
-/* Capabilities = 3 */
-
-typedef struct acpi_nhlt_device_specific_config_a
-{
-    UINT32                  CapabilitiesSize;
-    UINT8                   VirtualSlot;
-    UINT8                   ConfigType;
-    UINT8                   ArrayType;
-
-} ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_A;
-
-/* Capabilities = 3 */
-
-typedef struct acpi_nhlt_device_specific_config_d
-{
-    UINT8                   VirtualSlot;
-    UINT8                   ConfigType;
-    UINT8                   ArrayType;
-
-} ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_D;
-
-/* Values for Config Type above */
-
-#define ACPI_NHLT_CONFIG_TYPE_GENERIC              0x00
-#define ACPI_NHLT_CONFIG_TYPE_MIC_ARRAY            0x01
-#define ACPI_NHLT_CONFIG_TYPE_RENDER_FEEDBACK      0x03
-#define ACPI_NHLT_CONFIG_TYPE_RESERVED             0x04   /* 4 and above are reserved */
-
-/* Capabilities = 0 */
-
-typedef struct acpi_nhlt_device_specific_config_b
-{
-    UINT32                  CapabilitiesSize;
-
-} ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_B;
-
-/* Capabilities = 1 */
-
-typedef struct acpi_nhlt_device_specific_config_c
-{
-    UINT32                  CapabilitiesSize;
-    UINT8                   VirtualSlot;
-
-} ACPI_NHLT_DEVICE_SPECIFIC_CONFIG_C;
-
-typedef struct acpi_nhlt_render_device_specific_config
-{
-    UINT32                  CapabilitiesSize;
-    UINT8                   VirtualSlot;
+#define ACPI_NHLT_DIR_RENDER                 0
+#define ACPI_NHLT_DIR_CAPTURE                1
 
-} ACPI_NHLT_RENDER_DEVICE_SPECIFIC_CONFIG;
-
-typedef struct acpi_nhlt_wave_extensible
+typedef struct acpi_nhlt_config
 {
-    UINT16                  FormatTag;
-    UINT16                  ChannelCount;
-    UINT32                  SamplesPerSec;
-    UINT32                  AvgBytesPerSec;
-    UINT16                  BlockAlign;
-    UINT16                  BitsPerSample;
-    UINT16                  ExtraFormatSize;
-    UINT16                  ValidBitsPerSample;
-    UINT32                  ChannelMask;
-    UINT8                   SubFormatGuid[16];
-
-} ACPI_NHLT_WAVE_EXTENSIBLE;
+    UINT32                         CapabilitiesSize;
+    UINT8                          Capabilities[1];
 
-/* Values for ChannelMask above */
+} ACPI_NHLT_CONFIG;
 
-#define ACPI_NHLT_SPKR_FRONT_LEFT             0x1
-#define ACPI_NHLT_SPKR_FRONT_RIGHT            0x2
-#define ACPI_NHLT_SPKR_FRONT_CENTER           0x4
-#define ACPI_NHLT_SPKR_LOW_FREQ               0x8
-#define ACPI_NHLT_SPKR_BACK_LEFT              0x10
-#define ACPI_NHLT_SPKR_BACK_RIGHT             0x20
-#define ACPI_NHLT_SPKR_FRONT_LEFT_OF_CENTER   0x40
-#define ACPI_NHLT_SPKR_FRONT_RIGHT_OF_CENTER  0x80
-#define ACPI_NHLT_SPKR_BACK_CENTER            0x100
-#define ACPI_NHLT_SPKR_SIDE_LEFT              0x200
-#define ACPI_NHLT_SPKR_SIDE_RIGHT             0x400
-#define ACPI_NHLT_SPKR_TOP_CENTER             0x800
-#define ACPI_NHLT_SPKR_TOP_FRONT_LEFT         0x1000
-#define ACPI_NHLT_SPKR_TOP_FRONT_CENTER       0x2000
-#define ACPI_NHLT_SPKR_TOP_FRONT_RIGHT        0x4000
-#define ACPI_NHLT_SPKR_TOP_BACK_LEFT          0x8000
-#define ACPI_NHLT_SPKR_TOP_BACK_CENTER        0x10000
-#define ACPI_NHLT_SPKR_TOP_BACK_RIGHT         0x20000
-
-typedef struct acpi_nhlt_format_config
+typedef struct acpi_nhlt_gendevice_config
 {
-    ACPI_NHLT_WAVE_EXTENSIBLE   Format;
-    UINT32                      CapabilitySize;
-    UINT8                       Capabilities[];
+    UINT8                          VirtualSlot;
+    UINT8                          ConfigType;
 
-} ACPI_NHLT_FORMAT_CONFIG;
+} ACPI_NHLT_GENDEVICE_CONFIG;
 
-typedef struct acpi_nhlt_formats_config
-{
-    UINT8                   FormatsCount;
+/* Values for ConfigType field above */
 
-} ACPI_NHLT_FORMATS_CONFIG;
+#define ACPI_NHLT_CONFIGTYPE_GENERIC         0
+#define ACPI_NHLT_CONFIGTYPE_MICARRAY        1
 
-typedef struct acpi_nhlt_device_specific_hdr
+typedef struct acpi_nhlt_micdevice_config
 {
-    UINT8                   VirtualSlot;
-    UINT8                   ConfigType;
+    UINT8                          VirtualSlot;
+    UINT8                          ConfigType;
+    UINT8                          ArrayType;
 
-} ACPI_NHLT_DEVICE_SPECIFIC_HDR;
+} ACPI_NHLT_MICDEVICE_CONFIG;
 
-/* Types for ConfigType above */
+/* Values for ArrayType field above */
 
-#define ACPI_NHLT_GENERIC                   0
-#define ACPI_NHLT_MIC                       1
-#define ACPI_NHLT_RENDER                    3
-
-typedef struct acpi_nhlt_mic_device_specific_config
-{
-    ACPI_NHLT_DEVICE_SPECIFIC_HDR   DeviceConfig;
-    UINT8                           ArrayTypeExt;
-
-} ACPI_NHLT_MIC_DEVICE_SPECIFIC_CONFIG;
-
-/* Values for ArrayTypeExt above */
-
-#define ACPI_NHLT_ARRAY_TYPE_RESERVED               0x09 // 9 and below are reserved
-#define ACPI_NHLT_SMALL_LINEAR_2ELEMENT             0x0A
-#define ACPI_NHLT_BIG_LINEAR_2ELEMENT               0x0B
-#define ACPI_NHLT_FIRST_GEOMETRY_LINEAR_4ELEMENT    0x0C
-#define ACPI_NHLT_PLANAR_LSHAPED_4ELEMENT           0x0D
-#define ACPI_NHLT_SECOND_GEOMETRY_LINEAR_4ELEMENT   0x0E
-#define ACPI_NHLT_VENDOR_DEFINED                    0x0F
-#define ACPI_NHLT_ARRAY_TYPE_MASK                   0x0F
-#define ACPI_NHLT_ARRAY_TYPE_EXT_MASK               0x10
-
-#define ACPI_NHLT_NO_EXTENSION                      0x0
-#define ACPI_NHLT_MIC_SNR_SENSITIVITY_EXT           (1<<4)
-
-typedef struct acpi_nhlt_vendor_mic_count
-{
-    UINT8                           MicrophoneCount;
-
-} ACPI_NHLT_VENDOR_MIC_COUNT;
+#define ACPI_NHLT_ARRAYTYPE_LINEAR2_SMALL    0xA
+#define ACPI_NHLT_ARRAYTYPE_LINEAR2_BIG      0xB
+#define ACPI_NHLT_ARRAYTYPE_LINEAR4_GEO1     0xC
+#define ACPI_NHLT_ARRAYTYPE_PLANAR4_LSHAPED  0xD
+#define ACPI_NHLT_ARRAYTYPE_LINEAR4_GEO2     0xE
+#define ACPI_NHLT_ARRAYTYPE_VENDOR           0xF
 
 typedef struct acpi_nhlt_vendor_mic_config
 {
-    UINT8                   Type;
-    UINT8                   Panel;
-    UINT16                  SpeakerPositionDistance;    // mm
-    UINT16                  HorizontalOffset;           // mm
-    UINT16                  VerticalOffset;             // mm
-    UINT8                   FrequencyLowBand;           // 5*Hz
-    UINT8                   FrequencyHighBand;          // 500*Hz
-    UINT16                  DirectionAngle;             // -180 - + 180
-    UINT16                  ElevationAngle;             // -180 - + 180
-    UINT16                  WorkVerticalAngleBegin;     // -180 - + 180 with 2 deg step
-    UINT16                  WorkVerticalAngleEnd;       // -180 - + 180 with 2 deg step
-    UINT16                  WorkHorizontalAngleBegin;   // -180 - + 180 with 2 deg step
-    UINT16                  WorkHorizontalAngleEnd;     // -180 - + 180 with 2 deg step
+    UINT8                          Type;
+    UINT8                          Panel;
+    UINT16                         SpeakerPositionDistance;   /* mm */
+    UINT16                         HorizontalOffset;          /* mm */
+    UINT16                         VerticalOffset;            /* mm */
+    UINT8                          FrequencyLowBand;          /* 5*Hz */
+    UINT8                          FrequencyHighBand;         /* 500*Hz */
+    UINT16                         DirectionAngle;            /* -180 - +180 */
+    UINT16                         ElevationAngle;            /* -180 - +180 */
+    UINT16                         WorkVerticalAngleBegin;    /* -180 - +180 with 2 deg step */
+    UINT16                         WorkVerticalAngleEnd;      /* -180 - +180 with 2 deg step */
+    UINT16                         WorkHorizontalAngleBegin;  /* -180 - +180 with 2 deg step */
+    UINT16                         WorkHorizontalAngleEnd;    /* -180 - +180 with 2 deg step */
 
 } ACPI_NHLT_VENDOR_MIC_CONFIG;
 
 /* Values for Type field above */
 
-#define ACPI_NHLT_MIC_OMNIDIRECTIONAL       0
-#define ACPI_NHLT_MIC_SUBCARDIOID           1
-#define ACPI_NHLT_MIC_CARDIOID              2
-#define ACPI_NHLT_MIC_SUPER_CARDIOID        3
-#define ACPI_NHLT_MIC_HYPER_CARDIOID        4
-#define ACPI_NHLT_MIC_8_SHAPED              5
-#define ACPI_NHLT_MIC_RESERVED6             6 // 6 is reserved
-#define ACPI_NHLT_MIC_VENDOR_DEFINED        7
-#define ACPI_NHLT_MIC_RESERVED              8 // 8 and above are reserved
+#define ACPI_NHLT_MICTYPE_OMNIDIRECTIONAL    0
+#define ACPI_NHLT_MICTYPE_SUBCARDIOID        1
+#define ACPI_NHLT_MICTYPE_CARDIOID           2
+#define ACPI_NHLT_MICTYPE_SUPERCARDIOID      3
+#define ACPI_NHLT_MICTYPE_HYPERCARDIOID      4
+#define ACPI_NHLT_MICTYPE_8SHAPED            5
+#define ACPI_NHLT_MICTYPE_RESERVED           6
+#define ACPI_NHLT_MICTYPE_VENDORDEFINED      7
 
 /* Values for Panel field above */
 
-#define ACPI_NHLT_MIC_POSITION_TOP          0
-#define ACPI_NHLT_MIC_POSITION_BOTTOM       1
-#define ACPI_NHLT_MIC_POSITION_LEFT         2
-#define ACPI_NHLT_MIC_POSITION_RIGHT        3
-#define ACPI_NHLT_MIC_POSITION_FRONT        4
-#define ACPI_NHLT_MIC_POSITION_BACK         5
-#define ACPI_NHLT_MIC_POSITION_RESERVED     6 // 6 and above are reserved
+#define ACPI_NHLT_MICLOCATION_TOP             0
+#define ACPI_NHLT_MICLOCATION_BOTTOM          1
+#define ACPI_NHLT_MICLOCATION_LEFT            2
+#define ACPI_NHLT_MICLOCATION_RIGHT           3
+#define ACPI_NHLT_MICLOCATION_FRONT           4
+#define ACPI_NHLT_MICLOCATION_REAR            5
 
-typedef struct acpi_nhlt_vendor_mic_device_specific_config
+typedef struct acpi_nhlt_vendor_micdevice_config
 {
-    ACPI_NHLT_MIC_DEVICE_SPECIFIC_CONFIG    MicArrayDeviceConfig;
-    UINT8                                   NumberOfMicrophones;
-    ACPI_NHLT_VENDOR_MIC_CONFIG             MicConfig[];            // Indexed by NumberOfMicrophones
+    UINT8                          VirtualSlot;
+    UINT8                          ConfigType;
+    UINT8                          ArrayType;
+    UINT8                          MicsCount;
+    ACPI_NHLT_VENDOR_MIC_CONFIG    Mics[];
 
-} ACPI_NHLT_VENDOR_MIC_DEVICE_SPECIFIC_CONFIG;
+} ACPI_NHLT_VENDOR_MICDEVICE_CONFIG;
 
-/* Microphone SNR and Sensitivity extension */
-
-typedef struct acpi_nhlt_mic_snr_sensitivity_extension
+typedef union acpi_nhlt_device_config
 {
-    UINT32                  SNR;
-    UINT32                  Sensitivity;
-
-} ACPI_NHLT_MIC_SNR_SENSITIVITY_EXTENSION;
+    UINT8                                VirtualSlot;
+    ACPI_NHLT_GENDEVICE_CONFIG           Gen;
+    ACPI_NHLT_MICDEVICE_CONFIG           Mic;
+    ACPI_NHLT_VENDOR_MICDEVICE_CONFIG    VendorMic;
 
-/* Render device with feedback */
+} ACPI_NHLT_DEVICE_CONFIG;
 
-typedef struct acpi_nhlt_render_feedback_device_specific_config
+/* Inherited from Microsoft's WAVEFORMATEXTENSIBLE. */
+typedef struct acpi_nhlt_wave_formatext
 {
-    UINT8                               FeedbackVirtualSlot;    // Render slot in case of capture
-    UINT16                              FeedbackChannels;       // Informative only
-    UINT16                              FeedbackValidBitsPerSample;
+    UINT16                         FormatTag;
+    UINT16                         ChannelCount;
+    UINT32                         SamplesPerSec;
+    UINT32                         AvgBytesPerSec;
+    UINT16                         BlockAlign;
+    UINT16                         BitsPerSample;
+    UINT16                         ExtraFormatSize;
+    UINT16                         ValidBitsPerSample;
+    UINT32                         ChannelMask;
+    UINT8                          Subformat[16];
 
-} ACPI_NHLT_RENDER_FEEDBACK_DEVICE_SPECIFIC_CONFIG;
+} ACPI_NHLT_WAVE_FORMATEXT;
 
-/* Linux-specific structures */
-
-typedef struct acpi_nhlt_linux_specific_count
+typedef struct acpi_nhlt_format_config
 {
-    UINT8                               StructureCount;
+    ACPI_NHLT_WAVE_FORMATEXT       Format;
+    ACPI_NHLT_CONFIG               Config;
 
-} ACPI_NHLT_LINUX_SPECIFIC_COUNT;
+} ACPI_NHLT_FORMAT_CONFIG;
 
-typedef struct acpi_nhlt_linux_specific_data
+typedef struct acpi_nhlt_formats_config
 {
-    UINT8                               DeviceId[16];
-    UINT8                               DeviceInstanceId;
-    UINT8                               DevicePortId;
+    UINT8                          FormatsCount;
+    ACPI_NHLT_FORMAT_CONFIG        Formats[];
 
-} ACPI_NHLT_LINUX_SPECIFIC_DATA;
+} ACPI_NHLT_FORMATS_CONFIG;
 
-typedef struct acpi_nhlt_linux_specific_data_b
+typedef struct acpi_nhlt_device_info
 {
-    UINT8                               SpecificData[18];
+    UINT8                          Id[16];
+    UINT8                          InstanceId;
+    UINT8                          PortId;
 
-} ACPI_NHLT_LINUX_SPECIFIC_DATA_B;
+} ACPI_NHLT_DEVICE_INFO;
 
-typedef struct acpi_nhlt_table_terminator
+typedef struct acpi_nhlt_devices_info
 {
-    UINT32                  TerminatorValue;
-    UINT32                  TerminatorSignature;
+    UINT8                          DevicesCount;
+    ACPI_NHLT_DEVICE_INFO          Devices[];
 
-} ACPI_NHLT_TABLE_TERMINATOR;
+} ACPI_NHLT_DEVICES_INFO;
 
 
 /*******************************************************************************
@@ -2707,8 +3431,8 @@ typedef struct acpi_table_prmt_header
 
 typedef struct acpi_prmt_module_header
 {
-	UINT16                  Revision;
-	UINT16                  Length;
+    UINT16                  Revision;
+    UINT16                  Length;
 
 } ACPI_PRMT_MODULE_HEADER;
 
@@ -2846,6 +3570,148 @@ enum AcpiRasfStatus
 #define ACPI_RASF_STATUS                (0x1F<<3)
 
 
+/*******************************************************************************
+ *
+ * RAS2 - RAS2 Feature Table (ACPI 6.5)
+ *        Version 1
+ *
+ *
+ ******************************************************************************/
+
+typedef struct acpi_table_ras2 {
+    ACPI_TABLE_HEADER       Header;             /* Common ACPI table header */
+    UINT16                  Reserved;
+    UINT16                  NumPccDescs;
+
+} ACPI_TABLE_RAS2;
+
+/* RAS2 Platform Communication Channel Descriptor */
+
+typedef struct acpi_ras2_pcc_desc {
+    UINT8                   ChannelId;
+    UINT16                  Reserved;
+    UINT8                   FeatureType;
+    UINT32                  Instance;
+
+} ACPI_RAS2_PCC_DESC;
+
+/* RAS2 Platform Communication Channel Shared Memory Region */
+
+typedef struct acpi_ras2_shmem {
+    UINT32                  Signature;
+    UINT16                  Command;
+    UINT16                  Status;
+    UINT16                  Version;
+    UINT8                   Features[16];
+    UINT8                   SetCaps[16];
+    UINT16                  NumParamBlks;
+    UINT32                  SetCapsStatus;
+
+} ACPI_RAS2_SHMEM;
+
+/* RAS2 Parameter Block Structure for PATROL_SCRUB */
+
+typedef struct acpi_ras2_parameter_block
+{
+    UINT16                  Type;
+    UINT16                  Version;
+    UINT16                  Length;
+
+} ACPI_RAS2_PARAMETER_BLOCK;
+
+/* RAS2 Parameter Block Structure for PATROL_SCRUB */
+
+typedef struct acpi_ras2_patrol_scrub_param {
+    ACPI_RAS2_PARAMETER_BLOCK   Header;
+    UINT16                      Command;
+    UINT64                      ReqAddrRange[2];
+    UINT64                      ActlAddrRange[2];
+    UINT32                      Flags;
+    UINT32                      ScrubParamsOut;
+    UINT32                      ScrubParamsIn;
+
+} ACPI_RAS2_PATROL_SCRUB_PARAM;
+
+/* Masks for Flags field above */
+
+#define ACPI_RAS2_SCRUBBER_RUNNING      1
+
+/* RAS2 Parameter Block Structure for LA2PA_TRANSLATION */
+
+typedef struct acpi_ras2_la2pa_translation_parameter {
+    ACPI_RAS2_PARAMETER_BLOCK   Header;
+    UINT16                      AddrTranslationCommand;
+    UINT64                      SubInstId;
+    UINT64                      LogicalAddress;
+    UINT64                      PhysicalAddress;
+    UINT32                      Status;
+
+} ACPI_RAS2_LA2PA_TRANSLATION_PARAM;
+
+/* Channel Commands */
+
+enum AcpiRas2Commands
+{
+    ACPI_RAS2_EXECUTE_RAS2_COMMAND      = 1
+};
+
+/* Platform RAS2 Features */
+
+enum AcpiRas2Features
+{
+    ACPI_RAS2_PATROL_SCRUB_SUPPORTED    = 0,
+    ACPI_RAS2_LA2PA_TRANSLATION         = 1
+};
+
+/* RAS2 Patrol Scrub Commands */
+
+enum AcpiRas2PatrolScrubCommands
+{
+    ACPI_RAS2_GET_PATROL_PARAMETERS     = 1,
+    ACPI_RAS2_START_PATROL_SCRUBBER     = 2,
+    ACPI_RAS2_STOP_PATROL_SCRUBBER      = 3
+};
+
+/* RAS2 LA2PA Translation Commands */
+
+enum AcpiRas2La2PaTranslationCommands
+{
+    ACPI_RAS2_GET_LA2PA_TRANSLATION     = 1,
+};
+
+/* RAS2 LA2PA Translation Status values */
+
+enum AcpiRas2La2PaTranslationStatus
+{
+    ACPI_RAS2_LA2PA_TRANSLATION_SUCCESS = 0,
+    ACPI_RAS2_LA2PA_TRANSLATION_FAIL    = 1,
+};
+
+/* Channel Command flags */
+
+#define ACPI_RAS2_GENERATE_SCI          (1<<15)
+
+/* Status values */
+
+enum AcpiRas2Status
+{
+    ACPI_RAS2_SUCCESS                   = 0,
+    ACPI_RAS2_NOT_VALID                 = 1,
+    ACPI_RAS2_NOT_SUPPORTED             = 2,
+    ACPI_RAS2_BUSY                      = 3,
+    ACPI_RAS2_FAILED                    = 4,
+    ACPI_RAS2_ABORTED                   = 5,
+    ACPI_RAS2_INVALID_DATA              = 6
+};
+
+/* Status flags */
+
+#define ACPI_RAS2_COMMAND_COMPLETE      (1)
+#define ACPI_RAS2_SCI_DOORBELL          (1<<1)
+#define ACPI_RAS2_ERROR                 (1<<2)
+#define ACPI_RAS2_STATUS                (0x1F<<3)
+
+
 /*******************************************************************************
  *
  * RGRT - Regulatory Graphics Resource Table
@@ -2862,7 +3728,7 @@ typedef struct acpi_table_rgrt
     UINT16                  Version;
     UINT8                   ImageType;
     UINT8                   Reserved;
-    UINT8                   Image[0];
+    UINT8                   Image[];
 
 } ACPI_TABLE_RGRT;
 
@@ -2876,6 +3742,160 @@ enum AcpiRgrtImageType
 };
 
 
+/*******************************************************************************
+ *
+ * RHCT - RISC-V Hart Capabilities Table
+ *        Version 1
+ *
+ ******************************************************************************/
+
+typedef struct acpi_table_rhct {
+    ACPI_TABLE_HEADER       Header;             /* Common ACPI table header */
+    UINT32                  Flags;              /* RHCT flags */
+    UINT64                  TimeBaseFreq;
+    UINT32                  NodeCount;
+    UINT32                  NodeOffset;
+} ACPI_TABLE_RHCT;
+
+/* RHCT Flags */
+
+#define ACPI_RHCT_TIMER_CANNOT_WAKEUP_CPU       (1)
+/*
+ * RHCT subtables
+ */
+typedef struct acpi_rhct_node_header {
+    UINT16                  Type;
+    UINT16                  Length;
+    UINT16                  Revision;
+} ACPI_RHCT_NODE_HEADER;
+
+/* Values for RHCT subtable Type above */
+
+enum acpi_rhct_node_type {
+    ACPI_RHCT_NODE_TYPE_ISA_STRING = 0x0000,
+    ACPI_RHCT_NODE_TYPE_CMO        = 0x0001,
+    ACPI_RHCT_NODE_TYPE_MMU        = 0x0002,
+    ACPI_RHCT_NODE_TYPE_RESERVED   = 0x0003,
+    ACPI_RHCT_NODE_TYPE_HART_INFO  = 0xFFFF,
+};
+
+/*
+ * RHCT node specific subtables
+ */
+
+/* ISA string node structure */
+typedef struct acpi_rhct_isa_string {
+    UINT16                  IsaLength;
+    char                    Isa[];
+} ACPI_RHCT_ISA_STRING;
+
+typedef struct acpi_rhct_cmo_node {
+    UINT8                  Reserved;           /* Must be zero */
+    UINT8                  CbomSize;           /* CBOM size in powerof 2 */
+    UINT8                  CbopSize;           /* CBOP size in powerof 2 */
+    UINT8                  CbozSize;           /* CBOZ size in powerof 2 */
+} ACPI_RHCT_CMO_NODE;
+
+typedef struct acpi_rhct_mmu_node {
+    UINT8                   Reserved;          /* Must be zero */
+    UINT8                   MmuType;           /* Virtual Address Scheme */
+} ACPI_RHCT_MMU_NODE;
+
+enum acpi_rhct_mmu_type {
+    ACPI_RHCT_MMU_TYPE_SV39 = 0,
+    ACPI_RHCT_MMU_TYPE_SV48 = 1,
+    ACPI_RHCT_MMU_TYPE_SV57 = 2
+};
+
+/* Hart Info node structure */
+typedef struct acpi_rhct_hart_info {
+    UINT16                  NumOffsets;
+    UINT32                  Uid;                /* ACPI processor UID */
+} ACPI_RHCT_HART_INFO;
+
+/*******************************************************************************
+ *
+ * RIMT - RISC-V IO Remapping Table
+ *
+ * https://github.com/riscv-non-isa/riscv-acpi-rimt
+ *
+ ******************************************************************************/
+
+typedef struct acpi_table_rimt {
+    ACPI_TABLE_HEADER Header;              /* Common ACPI table header */
+    UINT32            NumNodes;            /* Number of RIMT Nodes */
+    UINT32            NodeOffset;          /* Offset to RIMT Node Array */
+    UINT32            Reserved;
+} ACPI_TABLE_RIMT;
+
+typedef struct acpi_rimt_node {
+    UINT8             Type;
+    UINT8             Revision;
+    UINT16            Length;
+    UINT16            Reserved;
+    UINT16            Id;
+    char              NodeData[];
+} ACPI_RIMT_NODE;
+
+enum acpi_rimt_node_type {
+    ACPI_RIMT_NODE_TYPE_IOMMU             = 0x0,
+    ACPI_RIMT_NODE_TYPE_PCIE_ROOT_COMPLEX = 0x1,
+    ACPI_RIMT_NODE_TYPE_PLAT_DEVICE       = 0x2,
+};
+
+typedef struct acpi_rimt_iommu {
+    UINT8             HardwareId[8];       /* Hardware ID */
+    UINT64            BaseAddress;         /* Base Address */
+    UINT32            Flags;               /* Flags */
+    UINT32            ProximityDomain;     /* Proximity Domain */
+    UINT16            PcieSegmentNumber;   /* PCIe Segment number */
+    UINT16            PcieBdf;             /* PCIe B/D/F */
+    UINT16            NumInterruptWires;   /* Number of interrupt wires */
+    UINT16            InterruptWireOffset; /* Interrupt wire array offset */
+    UINT64            InterruptWire[];     /* Interrupt wire array */
+} ACPI_RIMT_IOMMU;
+
+/* IOMMU Node Flags */
+#define ACPI_RIMT_IOMMU_FLAGS_PCIE      (1)
+#define ACPI_RIMT_IOMMU_FLAGS_PXM_VALID (1 << 1)
+
+/* Interrupt Wire Structure */
+typedef struct acpi_rimt_iommu_wire_gsi {
+    UINT32             IrqNum;             /* Interrupt Number */
+    UINT32             Flags;              /* Flags */
+} ACPI_RIMT_IOMMU_WIRE_GSI;
+
+/* Interrupt Wire Flags */
+#define ACPI_RIMT_GSI_LEVEL_TRIGGERRED  (1)
+#define ACPI_RIMT_GSI_ACTIVE_HIGH       (1 << 1)
+
+typedef struct acpi_rimt_id_mapping {
+    UINT32              SourceIdBase;      /* Source ID Base */
+    UINT32              NumIds;            /* Number of IDs */
+    UINT32              DestIdBase;        /* Destination Device ID Base */
+    UINT32              DestOffset;        /* Destination IOMMU Offset */
+    UINT32              Flags;             /* Flags */
+} ACPI_RIMT_ID_MAPPING;
+
+typedef struct acpi_rimt_pcie_rc {
+    UINT32              Flags;             /* Flags */
+    UINT16              Reserved;          /* Reserved */
+    UINT16              PcieSegmentNumber; /* PCIe Segment number */
+    UINT16              IdMappingOffset;   /* ID mapping array offset */
+    UINT16              NumIdMappings;     /* Number of ID mappings */
+} ACPI_RIMT_PCIE_RC;
+
+/* PCIe Root Complex Node Flags */
+#define ACPI_RIMT_PCIE_ATS_SUPPORTED   (1)
+#define ACPI_RIMT_PCIE_PRI_SUPPORTED   (1 << 1)
+
+typedef struct acpi_rimt_platform_device {
+    UINT16              IdMappingOffset;   /* ID Mapping array offset */
+    UINT16              NumIdMappings;     /* Number of ID mappings */
+    char                DeviceName[];      /* Device Object Name */
+} ACPI_RIMT_PLATFORM_DEVICE;
+
+
 /*******************************************************************************
  *
  * SBST - Smart Battery Specification Table
@@ -3075,6 +4095,30 @@ enum acpi_svkl_format
     ACPI_SVKL_FORMAT_RESERVED   = 1 /* 1 and greater are reserved */
 };
 
+/*******************************************************************************
+ *
+ * SWFT - SoundWire File Table
+ *        as described in Discovery and Configuration (DisCo) Specification
+ *        for SoundWire®
+ *        Version 1
+ *
+ ******************************************************************************/
+
+typedef struct acpi_table_swft
+{
+    ACPI_TABLE_HEADER       Header; /* Common ACPI table header */
+
+} ACPI_TABLE_SWFT;
+
+typedef struct acpi_swft_file
+{
+    UINT16                  VendorID;
+    UINT32                  FileID;
+    UINT16                  FileVersion;
+    UINT16                  FileLength;
+    UINT8                   FileData[];
+
+} ACPI_SWFT_FILE;
 
 /*******************************************************************************
  *
